#		-*- sh -*-
#
# SETUP v3
# Source Tree Builder And Compiler
# Developed for Generic NQS v3.50.0
#
# Copyright (c) 1995 The University of Sheffield
# Released under v2 of the GNU GPL
#
# Author(s) :
#
# Stuart Herbert
# Academic Computing Services
# The University of Sheffield
#
############################################################################
# WARNING
#
# To use SETUP, your computer's Bourne Shell (/bin/sh) must support shell
# scripts that define functions.  If your computer's Bourne Shell doesn't
# do this, you should modify the first line of this script to point to
# either /bin/ksh (Korn Shell) or to bash (GNU shell).
#
############################################################################

############################################################################
# GLOBAL VARIABLES
############################################################################

case "$TERM" in
  ansi*|linux|vt*|xterm*)
  COLOUR_NORMAL="[0m"
    COLOUR_BOLD="[1m"
    COLOUR_BLINK="[5m"
    ;;
  *)
    COLOUR_NORMAL=""
    COLOUR_BOLD=""
    COLOUR_BLINK=""
    ;;
esac

############################################################################
# SCREEN FUNCTIONS
############################################################################

endpage () { 
  echo
  separator
  pause
}

# $1 - Title of new page
newpage () {
  clear
  showbold "$1"
  separator
  echo
}

pause () {
  showbold "Press ENTER/RETURN to continue, or CTRL-C to quit."
  read < /dev/tty
}

sh_printf () {
  ${PRINTFDIR}/$machine/printf "$@"
}

separator () {
  echo "--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--"
}

showblink () {
  echo "${COLOUR_BLINK}$@${COLOUR_NORMAL}"
}

showbold () {
  echo "${COLOUR_BOLD}$@${COLOUR_NORMAL}"
}

shownormal () {
  echo "${COLOUR_NORMAL}$@"
}

############################################################################
# PRODUCT DESCRIPTION FUNCTIONS
############################################################################

AUTHOR () {
  AUTHOR="$1"
}

AUTHOR_EMAIL () {
  AUTHOR_EMAIL="$1"
}

BUILDNO () {
  BUILDNO="$1"
  VERSION="$VERSION.$1"
}

COPYRIGHT () {
  if [ "$COPYRIGHT" = "x" ]; then
    COPYRIGHT="  Copyright (c) $1\\n"
  else
    COPYRIGHT="$COPYRIGHT  Copyright (c) $1\\n"
  fi
}

COPYRIGHTEND () {
  COPYRIGHTEND="$1"
}

LASTRELEASE () {
  LASTRELEASE="$1"
}

PRODUCT () {
  PRODUCT="$1"
}

RELEASEDATE () {
  RELEASEDATE="$1"
}

VERSION () {
  VERSION="$1"
}

##########################################################################
# INPUT ROUTINES
##########################################################################

GetString () {
  if [ "$SILENT" = "TRUE" ]; then
    eval "$2=\"`eval echo \"$3\"`\""
    echo "$1 ($4) [$3] : $3"
  else
    ReadLine "$1" "$2" "$3" "$4"
  fi
}

# $1 - prompt
# $2 - variable to set
# $3 - default value
# $4 - (optional) - variable name that will eventually get set
ReadLine() {
  ReadLine_y=`eval echo \$"$4"`

  if [ -n "$4" ]; then
    if [ -z "$ReadLine_y" ]; then
      ReadLine_y=`eval echo "$3"`
    fi
  else
    ReadLine_y=`eval echo "$3"`
  fi

  sh_printf "$1 ($3): "
  read ReadLine_x

  if [ -z "$ReadLine_x" ]; then
    eval "$2=\"`eval echo \"$ReadLine_y\"`\""
  else
    eval "$2=\"`eval echo \"$ReadLine_x\"`\""
  fi
}
